
c========================================================================
      SUBROUTINE DATA_READ(mean_e_all,  std_e_all, five_e_all,
     >                    tfive_e_all,  med_e_all,sfive_e_all,
     >                    nfive_e_all,
     >                     mean_i_all,  std_i_all, five_i_all,
     >                    tfive_i_all,  med_i_all,sfive_i_all,
     >                    nfive_i_all, sc_pot_all)
c========================================================================
c  data_read.f
c  Read in averaged MPA data from ascii text files.

      IMPLICIT NONE

c     DEFINE INTEGER VARIABLES
      INTEGER(KIND=8) VBZS, ENS, LTS, VALS
      INTEGER(KIND=8) I, J, K

c     DEFINE PARAMETERS
      PARAMETER(VBZS=33, ENS=40, LTS=24, VALS=7)

c     DEFINE REAL ARRAYS
      REAL(KIND=8) mean_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) std_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) five_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) tfive_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) med_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) sfive_e_all(VBZS,ENS,LTS)
      REAL(KIND=8) nfive_e_all(VBZS,ENS,LTS)

      REAL(KIND=8) mean_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) std_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) five_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) tfive_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) med_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) sfive_i_all(VBZS,ENS,LTS)
      REAL(KIND=8) nfive_i_all(VBZS,ENS,LTS)

      REAL(KIND=8) sc_pot_all(VBZS,LTS)

      REAL(KIND=8) en_he,en_hp,log_en_he,log_en_hp

c     DEFINE CHARACTER VARIABLES
      CHARACTER*100 DUMMY_TXT
      CHARACTER*100 e_file_all
      CHARACTER*100 i_file_all

       CHARACTER*100 sc_pot_file_all

      e_file_all='data/model_e_array_all.txt'
      i_file_all='data/model_i_array_all.txt'

      sc_pot_file_all='data/u_sc_pot_.psav_array.txt'

c     ARRAYS ARE OF THE FORM array(28, 40, 24)
c     33 VALUES OF -vBz
c     40 ENERGIES DEFINED IN en_he and en_hp
c     24 LOCAL TIMES from 0 to 23.

      WRITE(6,*) 'READING DATA...'

c     ==========================ALL F10.7================================

c     READ IN ELECTRON FLUXES (ALL F10.7)
      OPEN(UNIT=21, FILE=e_file_all, STATUS='OLD')
      READ(21,'(A)') DUMMY_TXT
      DO 25 I=1,VBZS
        DO 10 J=1,ENS
          READ(21,200) (mean_e_all(I,J,K),K=1,24)
 10     CONTINUE    
        DO 12 J=1,ENS
          READ(21,200) (std_e_all(I,J,K),K=1,24)
 12     CONTINUE
        DO 14 J=1,ENS
          READ(21,200) (five_e_all(I,J,K),K=1,24)
 14     CONTINUE    
        DO 16 J=1,ENS
          READ(21,200) (tfive_e_all(I,J,K),K=1,24)
 16     CONTINUE
        DO 18 J=1,ENS
          READ(21,200) (med_e_all(I,J,K),K=1,24)
 18     CONTINUE
        DO 20 J=1,ENS
          READ(21,200) (sfive_e_all(I,J,K),K=1,24)
 20     CONTINUE
        DO 22 J=1,ENS
          READ(21,200) (nfive_e_all(I,J,K),K=1,24)
 22     CONTINUE    
 25   CONTINUE
      CLOSE(UNIT=21)

c     READ IN ION FLUXES (ALL F10.7)
      OPEN(UNIT=22, FILE=i_file_all, STATUS='OLD')
      READ(22,'(A)') DUMMY_TXT
      DO 45 I=1,VBZS
        DO 30 J=1,ENS
          READ(22,200) (mean_i_all(I,J,K),K=1,24)
 30     CONTINUE    
        DO 32 J=1,ENS
          READ(22,200) (std_i_all(I,J,K),K=1,24)
 32     CONTINUE    
        DO 34 J=1,ENS
          READ(22,200) (five_i_all(I,J,K),K=1,24)
 34    CONTINUE    
        DO 36 J=1,ENS
          READ(22,200) (tfive_i_all(I,J,K),K=1,24)
 36     CONTINUE    
        DO 38 J=1,ENS
          READ(22,200) (med_i_all(I,J,K),K=1,24)
 38    CONTINUE    
        DO 40 J=1,ENS
          READ(22,200) (sfive_i_all(I,J,K),K=1,24)
 40    CONTINUE    
        DO 42 J=1,ENS
          READ(22,200) (nfive_i_all(I,J,K),K=1,24)
 42    CONTINUE    
 45   CONTINUE
      CLOSE(UNIT=22)

c     READ IN SC POTENTIAL  (F10.7 >= ALL F107)
      OPEN(UNIT=29, FILE=sc_pot_file_all, STATUS='OLD')
      DO 185 I=1,VBZS
          READ(29,210) (sc_pot_all(I,J),J=1,24)
 185  CONTINUE
      CLOSE(UNIT=29)

 200  FORMAT(24E18.6)
 210  FORMAT(24D24.12)

c 201  FORMAT(I6, I6, 2D18.6)

      WRITE(6,*) 'FLUX DATA READ IN COMPLETE!'

      RETURN

      END
c===================END SUBROUTINE DATA_READ=============================
